var nowPlayingList = Components.classes["@j.c.m/NowPlaying/List;1"].getService().wrappedJSObject;

function onLoadPane(aEvent) {
  
  var playlist = document.getElementById("playlist");
  
  /* Override original implementation */
  playlist._removeSelectedTracks = playlist.removeSelectedTracks;
  playlist.removeSelectedTracks = function() {
    switch (this._npl.mode) {
    case this._npl.MODE_BASIC :
      if (this._prefMgr.getBoolPref("extensions.nowplaying@j.c.m.fork")) {
        var enumerator = this.mediaListView.selection.selectedIndexedMediaItems;
        
        this._npl._fillList();
        this._npl.setMode(this._npl.MODE_CUSTOM);
        this._npl.list.removeSome(enumerator);
      } else {
        
        // original implementation
        this._removeSelectedTracks();
        
      }
      break;
    case this._npl.MODE_CUSTOM :
    case this._npl.MODE_QUEUE :
      this.mediaListView.removeSelectedMediaItems();
    }
    this._npl._update();
  };
  
  /* Override original implementation */
  playlist.__setupColumns = playlist._setupColumns;
  playlist._setupColumns = function() {
    if (this._columnsAlreadySetup) return;
    this._columnsAlreadySetup = true;
    
    // original implementation
    this.__setupColumns();
  };
  
  nowPlayingList.bindPlaylist(playlist);
  window.removeEventListener("load", onLoadPane, false);
}



function onUnloadPane(aEvent) {
  
  nowPlayingList.unbindPlaylist();
  window.removeEventListener("unload", onUnloadPane, false);
}



function toggleMode() {
  
  var newMode = nowPlayingList.mode + 1;
  if (newMode == nowPlayingList.MODE_CUSTOM) {
    nowPlayingList._fillList();
  }
  
  // mode will wrap around to 0 if too big
  nowPlayingList.setMode(newMode);
}



window.addEventListener("load", onLoadPane, false);
window.addEventListener("unload", onUnloadPane, false);
